/*
 * Author:          Patrick-Christopher Mattulat
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2020-08-17
 * Changed:         2024-05-31
 *
 * */

#ifndef LS_STD_FILE_NOT_FOUND_EXCEPTION_HPP
#define LS_STD_FILE_NOT_FOUND_EXCEPTION_HPP

#include <ls-std/core/definition.hpp>
#include <ls-std/core/exception/Exception.hpp>

namespace ls::std::core
{
  ls_std_class FileNotFoundException final : public Exception
  {
    public:

      FileNotFoundException();
      explicit FileNotFoundException(const ::std::string &_message);
      ~FileNotFoundException() noexcept override;

      [[nodiscard]] const char *what() const noexcept override;
  };
}

#endif
