/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2023-03-27
* Changed:         2024-05-31
*
* */

#ifndef LS_STD_NOT_IMPLEMENTED_EXCEPTION_HPP
#define LS_STD_NOT_IMPLEMENTED_EXCEPTION_HPP

#include <ls-std/core/definition.hpp>
#include "Exception.hpp"

namespace ls::std::core
{
  ls_std_class NotImplementedException final : public Exception
  {
    public:

      NotImplementedException();
      explicit NotImplementedException(const ::std::string &_message);
      ~NotImplementedException() noexcept override;

      [[nodiscard]] const char *what() const noexcept override;
  };
}

#endif
