/*
 * Author:          Patrick-Christopher Mattulat
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2020-08-21
 * Changed:         2024-05-31
 *
 * */

#ifndef LS_STD_I_SERIALIZABLE_HPP
#define LS_STD_I_SERIALIZABLE_HPP

#include <ls-std/core/definition.hpp>
#include <ls-std/core/type/Types.hpp>

namespace ls::std::core::interface_type
{
  ls_std_class ISerializable
  {
    public:

      ISerializable();
      virtual ~ISerializable();

      virtual type::byte_field marshal() = 0;
      virtual void unmarshal(const type::byte_field &_data) = 0;
  };
}

#endif
